/*
** xicontris.c for Mtds in .
** 
** Made by MaxTheDogSays (dubray_f@epita.fr && rancur_v@epita.fr
** Login   <mtds@epita.fr>
** 
** Started on  Tue May  3 23:29:35 1994 mtds
** Last update Mon Nov 21 12:59:29 1994 hydrix
*/

#include <X11/Intrinsic.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <Xmtds/Tetris.h>
#include <Xmtds/Logo.h>

typedef struct	_appl
{
   XtAppContext	app_context;
   Widget	toplevel;
   Widget	shell;
   Widget	tetris;
   Widget	logo;
} appl;

static void	score_callback();

int		main(argc,argv)
int		argc;
char		**argv;
{
   appl		app;
   XWMHints	xwmh;
      
   app.toplevel =
      XtVaAppInitialize(&(app.app_context),
			"XicontrisT",
			NULL,
			0,
			&argc,
			argv,
			NULL,
			XtNwidth,	100,
			XtNheight,	100,
			NULL);
   app.logo =
      XtVaCreateManagedWidget("logo",
			      xmtdsLogoWidgetClass,
			      app.toplevel,
			      NULL);
   app.shell =
      XtVaCreatePopupShell("popup",
			   transientShellWidgetClass,
			   app.toplevel,
			   NULL);
   app.tetris =
      XtVaCreateManagedWidget("tetris",
			      xmtdsTetrisWidgetClass,
			      app.shell,
			      XtNcolorList,"purple salmon blue2 gray50 red",
			      NULL);
   XtAddCallback(app.tetris,
                 XtNscoreCallback,
                 score_callback,
                 &app);
   XtRealizeWidget(app.toplevel);
   XtPopup(app.shell,XtGrabNone);
   XmtdsTetrisClear(app.tetris);
   XmtdsTetrisStart(app.tetris);
   xwmh.flags = StateHint|IconWindowHint;
   xwmh.initial_state = IconicState;
   xwmh.icon_window = XtWindow(app.shell);
   XSetWMHints(XtDisplay(app.toplevel),
	       XtWindow(app.toplevel),
	       &xwmh);
   XtAppMainLoop(app.app_context);
}

static void			score_callback(w,app,cbs)
Widget				w;
appl				*app;
xmtdsscoreCallbackStruct	*cbs;
{
   if (cbs->reason == SCORE_END)
   {
      XmtdsTetrisClear(app->tetris);
      XmtdsTetrisStart(app->tetris);
   }
}
